Require Import bool.
Require Import connectives.
Require Import leibniz.
Require Import logic.
Require Import nat.
Definition sameF_upto : forall (A:Type), nat.nat -> (nat.nat -> A) -> (nat.nat -> A) -> Prop := fun (A:Type) => fun (k:nat.nat) => fun (f:(nat.nat -> A)) => fun (g:(nat.nat -> A)) => forall (i:nat.nat), (nat.lt i k) -> logic.eq (A) (f i) (g i).
Definition sameF_p : forall (A:Type), nat.nat -> (nat.nat -> bool.bool) -> (nat.nat -> A) -> (nat.nat -> A) -> Prop := fun (A:Type) => fun (k:nat.nat) => fun (p:(nat.nat -> bool.bool)) => fun (f:(nat.nat -> A)) => fun (g:(nat.nat -> A)) => forall (i:nat.nat), (nat.lt i k) -> (logic.eq (bool.bool) (p i) bool.true) -> logic.eq (A) (f i) (g i).
Definition sameF_upto_le : forall A, forall (f:(nat.nat -> A)), forall (g:(nat.nat -> A)), forall (n:nat.nat), forall (m:nat.nat), (nat.le n m) -> (sameF_upto (A) m f g) -> sameF_upto (A) n f g := fun (A:Type) => fun (f:nat.nat -> A) => fun (g:nat.nat -> A) => fun (n:nat.nat) => fun (m:nat.nat) => fun (lenm:nat.le n m) => (fun (samef:sameF_upto (A) m f g) => (fun (i:nat.nat) => fun (ltin:nat.lt i n) => (((samef) (i)) ((((((nat.lt_to_le_to_lt) (i)) (n)) (m)) (ltin)) (lenm))))).
Definition sameF_p_le : forall A, forall (p:(nat.nat -> bool.bool)), forall (f:(nat.nat -> A)), forall (g:(nat.nat -> A)), forall (n:nat.nat), forall (m:nat.nat), (nat.le n m) -> (sameF_p (A) m p f g) -> sameF_p (A) n p f g := fun (A:Type) => fun (p:nat.nat -> bool.bool) => fun (f:nat.nat -> A) => fun (g:nat.nat -> A) => fun (n:nat.nat) => fun (m:nat.nat) => fun (lenm:nat.le n m) => (fun (samef:sameF_p (A) m p f g) => (fun (i:nat.nat) => fun (ltin:nat.lt i n) => (fun (pi:logic.eq (bool.bool) (p i) bool.true) => ((((samef) (i)) ((((((nat.lt_to_le_to_lt) (i)) (n)) (m)) (ltin)) (lenm))) (((((((logic.rewrite_r) (bool.bool)) (bool.true)) (fun (__:bool.bool) => logic.eq (bool.bool) __ bool.true)) (((logic.refl) (bool.bool)) (bool.true))) (p i)) (pi)))))).
Parameter bigop : forall (H:Type), nat.nat -> (nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H.
Parameter bigop_body : forall (H:Type), nat.nat -> (nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H.
Axiom axiom_bigop_O : forall H, connectives.equal ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop (H) nat.O) (bigop_body (H) nat.O).
Definition eq_bigop_O : forall H, leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop (H) nat.O) (bigop_body (H) nat.O) := fun (H:Type) => ((((connectives.equal_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop (H) nat.O)) (bigop_body (H) nat.O)) ((axiom_bigop_O) (H)).
Definition sym_eq_bigop_O : forall H, leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) nat.O) (bigop (H) nat.O) := fun (H:Type) => ((((leibniz.sym_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop (H) nat.O)) (bigop_body (H) nat.O)) ((eq_bigop_O) (H)).
Axiom axiom_bigop_S : forall H, forall (n:nat.nat), connectives.equal ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop (H) (nat.S n)) (bigop_body (H) (nat.S n)).
Definition eq_bigop_S : forall H, forall (n:nat.nat), leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop (H) (nat.S n)) (bigop_body (H) (nat.S n)) := fun (H:Type) => fun (n:nat.nat) => ((((connectives.equal_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop (H) (nat.S n))) (bigop_body (H) (nat.S n))) (((axiom_bigop_S) (H)) (n)).
Definition sym_eq_bigop_S : forall H, forall (n:nat.nat), leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) (nat.S n)) (bigop (H) (nat.S n)) := fun (H:Type) => fun (n:nat.nat) => ((((leibniz.sym_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop (H) (nat.S n))) (bigop_body (H) (nat.S n))) (((eq_bigop_S) (H)) (n)).
Axiom axiom_bigop_body_O : forall H, connectives.equal ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) nat.O) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => nil).
Definition eq_bigop_body_O : forall H, leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) nat.O) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => nil) := fun (H:Type) => ((((connectives.equal_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop_body (H) nat.O)) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => nil)) ((axiom_bigop_body_O) (H)).
Definition sym_eq_bigop_body_O : forall H, leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => nil) (bigop_body (H) nat.O) := fun (H:Type) => ((((leibniz.sym_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop_body (H) nat.O)) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => nil)) ((eq_bigop_body_O) (H)).
Axiom axiom_bigop_body_S : forall H, forall (n:nat.nat), connectives.equal ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) (nat.S n)) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => bool.match_bool_type (H) (op (f n) (bigop (H) n p nil op f)) (bigop (H) n p nil op f) (p n)).
Definition eq_bigop_body_S : forall H, forall (n:nat.nat), leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) (nat.S n)) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => bool.match_bool_type (H) (op (f n) (bigop (H) n p nil op f)) (bigop (H) n p nil op f) (p n)) := fun (H:Type) => fun (n:nat.nat) => ((((connectives.equal_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop_body (H) (nat.S n))) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => bool.match_bool_type (H) (op (f n) (bigop (H) n p nil op f)) (bigop (H) n p nil op f) (p n))) (((axiom_bigop_body_S) (H)) (n)).
Definition sym_eq_bigop_body_S : forall H, forall (n:nat.nat), leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => bool.match_bool_type (H) (op (f n) (bigop (H) n p nil op f)) (bigop (H) n p nil op f) (p n)) (bigop_body (H) (nat.S n)) := fun (H:Type) => fun (n:nat.nat) => ((((leibniz.sym_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop_body (H) (nat.S n))) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => bool.match_bool_type (H) (op (f n) (bigop (H) n p nil op f)) (bigop (H) n p nil op f) (p n))) (((eq_bigop_body_S) (H)) (n)).
Definition same_bigop : forall B, forall (k:nat.nat), forall (p1:(nat.nat -> bool.bool)), forall (p2:(nat.nat -> bool.bool)), forall (nil:B), forall (op:(B -> B -> B)), forall (f:(nat.nat -> B)), forall (g:(nat.nat -> B)), (sameF_upto (bool.bool) k p1 p2) -> (sameF_p (B) k p1 f g) -> logic.eq (B) (bigop (B) k (fun (i:nat.nat) => p1 i) nil op (fun (i:nat.nat) => f i)) (bigop (B) k (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)) := fun (B:Type) => fun (k:nat.nat) => fun (p1:nat.nat -> bool.bool) => fun (p2:nat.nat -> bool.bool) => fun (nil:B) => fun (op:B -> B -> B) => fun (f:nat.nat -> B) => fun (g:nat.nat -> B) => ((((nat.nat_ind) (fun (_x_365:nat.nat) => (sameF_upto (bool.bool) _x_365 p1 p2) -> (sameF_p (B) _x_365 p1 f g) -> logic.eq (B) (bigop (B) _x_365 (fun (i:nat.nat) => p1 i) nil op (fun (i:nat.nat) => f i)) (bigop (B) _x_365 (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)))) ((((sym_eq_bigop_O) (B)) (fun (y:((nat.nat -> bool.bool) -> B -> (B -> B -> B) -> (nat.nat -> B) -> B)) => (sameF_upto (bool.bool) nat.O p1 p2) -> (sameF_p (B) nat.O p1 f g) -> logic.eq (B) (bigop (B) nat.O (fun (i:nat.nat) => p1 i) nil op (fun (i:nat.nat) => f i)) (y (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)))) ((((sym_eq_bigop_body_O) (B)) (fun (y:((nat.nat -> bool.bool) -> B -> (B -> B -> B) -> (nat.nat -> B) -> B)) => (sameF_upto (bool.bool) nat.O p1 p2) -> (sameF_p (B) nat.O p1 f g) -> logic.eq (B) (bigop (B) nat.O (fun (i:nat.nat) => p1 i) nil op (fun (i:nat.nat) => f i)) (y (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)))) ((((eq_bigop_body_O) (B)) (fun (y:((nat.nat -> bool.bool) -> B -> (B -> B -> B) -> (nat.nat -> B) -> B)) => (sameF_upto (bool.bool) nat.O p1 p2) -> (sameF_p (B) nat.O p1 f g) -> logic.eq (B) (bigop (B) nat.O (fun (i:nat.nat) => p1 i) nil op (fun (i:nat.nat) => f i)) (y (fun (i:nat.nat) => p1 i) nil op (fun (i:nat.nat) => f i)))) ((((eq_bigop_O) (B)) (fun (y:((nat.nat -> bool.bool) -> B -> (B -> B -> B) -> (nat.nat -> B) -> B)) => (sameF_upto (bool.bool) nat.O p1 p2) -> (sameF_p (B) nat.O p1 f g) -> logic.eq (B) (bigop (B) nat.O (fun (i:nat.nat) => p1 i) nil op (fun (i:nat.nat) => f i)) (y (fun (i:nat.nat) => p1 i) nil op (fun (i:nat.nat) => f i)))) (fun (auto:sameF_upto (bool.bool) nat.O p1 p2) => (fun (auto':sameF_p (B) nat.O p1 f g) => (((logic.refl) (B)) (bigop (B) nat.O (fun (i:nat.nat) => p1 i) nil op (fun (i:nat.nat) => f i)))))))))) (fun (n:nat.nat) => ((((sym_eq_bigop_S) (B)) (n)) (fun (y:((nat.nat -> bool.bool) -> B -> (B -> B -> B) -> (nat.nat -> B) -> B)) => ((sameF_upto (bool.bool) n p1 p2) -> (sameF_p (B) n p1 f g) -> logic.eq (B) (bigop (B) n (fun (i:nat.nat) => p1 i) nil op (fun (i:nat.nat) => f i)) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) -> (sameF_upto (bool.bool) (nat.S n) p1 p2) -> (sameF_p (B) (nat.S n) p1 f g) -> logic.eq (B) (bigop (B) (nat.S n) (fun (i:nat.nat) => p1 i) nil op (fun (i:nat.nat) => f i)) (y (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)))) (((((sym_eq_bigop_S) (B)) (n)) (fun (y:((nat.nat -> bool.bool) -> B -> (B -> B -> B) -> (nat.nat -> B) -> B)) => ((sameF_upto (bool.bool) n p1 p2) -> (sameF_p (B) n p1 f g) -> logic.eq (B) (bigop (B) n (fun (i:nat.nat) => p1 i) nil op (fun (i:nat.nat) => f i)) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) -> (sameF_upto (bool.bool) (nat.S n) p1 p2) -> (sameF_p (B) (nat.S n) p1 f g) -> logic.eq (B) (y (fun (i:nat.nat) => p1 i) nil op (fun (i:nat.nat) => f i)) (bigop_body (B) (nat.S n) (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)))) (((((sym_eq_bigop_body_S) (B)) (n)) (fun (y:((nat.nat -> bool.bool) -> B -> (B -> B -> B) -> (nat.nat -> B) -> B)) => ((sameF_upto (bool.bool) n p1 p2) -> (sameF_p (B) n p1 f g) -> logic.eq (B) (bigop (B) n (fun (i:nat.nat) => p1 i) nil op (fun (i:nat.nat) => f i)) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) -> (sameF_upto (bool.bool) (nat.S n) p1 p2) -> (sameF_p (B) (nat.S n) p1 f g) -> logic.eq (B) (y (fun (i:nat.nat) => p1 i) nil op (fun (i:nat.nat) => f i)) (bigop_body (B) (nat.S n) (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)))) (((((sym_eq_bigop_body_S) (B)) (n)) (fun (y:((nat.nat -> bool.bool) -> B -> (B -> B -> B) -> (nat.nat -> B) -> B)) => ((sameF_upto (bool.bool) n p1 p2) -> (sameF_p (B) n p1 f g) -> logic.eq (B) (bigop (B) n (fun (i:nat.nat) => p1 i) nil op (fun (i:nat.nat) => f i)) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) -> (sameF_upto (bool.bool) (nat.S n) p1 p2) -> (sameF_p (B) (nat.S n) p1 f g) -> logic.eq (B) (((fun (p:(nat.nat -> bool.bool)) => fun (nil0:B) => fun (op0:(B -> B -> B)) => fun (f0:(nat.nat -> B)) => bool.match_bool_type (B) (op0 (f0 n) (bigop (B) n p nil0 op0 f0)) (bigop (B) n p nil0 op0 f0) (p n)) (fun (i:nat.nat) => p1 i)) nil op (fun (i:nat.nat) => f i)) (y (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)))) (fun (Hind:(sameF_upto (bool.bool) n p1 p2) -> (sameF_p (B) n p1 f g) -> logic.eq (B) (bigop (B) n (fun (i:nat.nat) => p1 i) nil op (fun (i:nat.nat) => f i)) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) => (fun (samep:sameF_upto (bool.bool) (nat.S n) p1 p2) => (fun (samef:sameF_p (B) (nat.S n) p1 f g) => (((((((logic.eq_ind_r) (B)) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) (fun (x:B) => logic.eq (B) (bool.match_bool_type (B) (op (f n) x) x (p1 n)) (bool.match_bool_type (B) (op (g n) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)) (p2 n)))) (((((((logic.eq_ind) (bool.bool)) (p1 n)) (fun (x_1:bool.bool) => logic.eq (B) (bool.match_bool_type (B) (op (f n) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)) (p1 n)) (bool.match_bool_type (B) (op (g n) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)) x_1))) (((((((connectives.match_Or_prop) (logic.eq (bool.bool) (p1 n) bool.true)) (logic.eq (bool.bool) (p1 n) bool.false)) (logic.eq (B) (bool.match_bool_type (B) (op (f n) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)) (p1 n)) (bool.match_bool_type (B) (op (g n) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)) (p1 n)))) (fun (H1:logic.eq (bool.bool) (p1 n) bool.true) => (((((((logic.eq_ind_r) (bool.bool)) (bool.true)) (fun (x:bool.bool) => logic.eq (B) (bool.match_bool_type (B) (op (f n) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)) x) (bool.match_bool_type (B) (op (g n) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)) x))) ((((((bool.sym_eq_match_bool_type_true) (B)) (op (f n) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)))) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) (fun (y:B) => logic.eq (B) y (bool.match_bool_type (B) (op (g n) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)) bool.true))) ((((((bool.sym_eq_match_bool_type_true) (B)) (op (g n) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)))) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) (fun (y:B) => logic.eq (B) (op (f n) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) y)) (((((((logic.eq_ind) (B)) (f n)) (fun (x_1:B) => logic.eq (B) (op (f n) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) (op x_1 (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))))) (((logic.refl) (B)) (op (f n) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))))) (g n)) ((((samef) (n)) ((nat.le_n) (nat.S n))) (H1)))))) (p1 n)) (H1)))) (fun (H1:logic.eq (bool.bool) (p1 n) bool.false) => (((((((logic.eq_ind_r) (bool.bool)) (bool.false)) (fun (x:bool.bool) => logic.eq (B) (bool.match_bool_type (B) (op (f n) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)) x) (bool.match_bool_type (B) (op (g n) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)) x))) ((((((bool.sym_eq_match_bool_type_false) (B)) (op (f n) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)))) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) (fun (y:B) => logic.eq (B) y (bool.match_bool_type (B) (op (g n) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)) bool.false))) ((((((bool.sym_eq_match_bool_type_false) (B)) (op (g n) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)))) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i))) (fun (y:B) => logic.eq (B) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)) y)) (((logic.refl) (B)) (bigop (B) n (fun (i:nat.nat) => p2 i) nil op (fun (i:nat.nat) => g i)))))) (p1 n)) (H1)))) ((bool.true_or_false) (p1 n)))) (p2 n)) (((samep) (n)) ((nat.le_n) (nat.S n))))) (bigop (B) n (fun (i:nat.nat) => p1 i) nil op (fun (i:nat.nat) => f i))) (((Hind) ((((((((sameF_upto_le) (bool.bool)) (p1)) (p2)) (n)) (nat.S n)) (((((logic.eq_coerc) (nat.le (nat.pred (nat.S n)) (nat.S n))) (nat.le n (nat.S n))) ((nat.le_pred_n) (nat.S n))) (((((((logic.rewrite_l) (nat.nat)) (n)) (fun (__:nat.nat) => logic.eq (Prop) (nat.le __ (nat.S n)) (nat.le n (nat.S n)))) (((logic.refl) (Prop)) (nat.le n (nat.S n)))) (nat.pred (nat.S n))) ((nat.pred_Sn) (n))))) (samep))) (((((((((sameF_p_le) (B)) (p1)) (f)) (g)) (n)) (nat.S n)) (((((logic.eq_coerc) (nat.le (nat.pred (nat.S n)) (nat.S n))) (nat.le n (nat.S n))) ((nat.le_pred_n) (nat.S n))) (((((((logic.rewrite_l) (nat.nat)) (n)) (fun (__:nat.nat) => logic.eq (Prop) (nat.le __ (nat.S n)) (nat.le n (nat.S n)))) (((logic.refl) (Prop)) (nat.le n (nat.S n)))) (nat.pred (nat.S n))) ((nat.pred_Sn) (n))))) (samef)))))))))))) (k).
